#Generated application by SAGE MBB plateform

#@author khalid.belkhir@univ-montp2.fr
#vcfparser is GPLv3 software, authored and maintained by Khalid Belkhir
#Rscript -e 'shiny::runApp(".", host="127.0.0.1", port=4123)' &
    
library(shiny)
library(shinydashboard)
library(shinyjs)
library(DT)
library(ggplot2)
library(tidyverse)
library("patchwork")
library(shinycssloaders)
options(encoding = 'UTF-8', shiny.maxRequestSize=130*1024^2) #30MB
source ("Draw_fonction.R")

UI <- dashboardPage(

    skin = "blue",

    dashboardHeader(title = "ShinyVCFparser"),

    dashboardSidebar(sidebarMenu(id = "sidebarmenu",
    menuItem("ShinyVCFparser"),



    menuItem("Home", tabName = "page1"),
fileInput("vcf_file", label = "Your VCF file :", multiple = TRUE, accept = c()),

    tags$br(), tags$br(), tags$br(),

    menuItem("Team", icon = icon("book", lib="font-awesome"),
        menuItem("Jimmy Lopez",  href = "http://www.isem.univ-montp2.fr/fr/personnel/plateformes/calcul-et-bioinformatique-mbb/lopez-jimmy.index/", newtab = TRUE, icon = shiny::icon("male"), selected = NULL ),
        menuItem("Khalid Belkhir",  href = "http://www.isem.univ-montp2.fr/fr/personnel/plateformes/calcul-et-bioinformatique-mbb/belkhir-khalid.index/", newtab = TRUE, icon = shiny::icon("male"), selected = NULL  )
    )

)),

    dashboardBody(tabItems(
        tabItem(tabName = "page1",
            fluidPage(

            box(width = 12, 
            title = "Charts",
            collapsible = TRUE,
            status = "primary",
            solidHeader = TRUE,
            plotOutput("Plots1",width = "100%", height = "800px") %>% withSpinner(color="#0dc5c1")
            
            ),
            box(width = 12, 
            title = "Processed SNP Info",
            collapsible = TRUE,
            status = "primary",
            solidHeader = TRUE,
            DT::dataTableOutput("IntermediateState") %>% withSpinner(color="#0dc5c1")
            )
            )
        )
)))

summarizeVCF <- function(vcfFile)
{
  ficout = tempfile()  
  x <- system(paste0('bash ./parseVCF.sh ', vcfFile,'  ',ficout), intern=TRUE)
  return( ficout)
}    
SERVER <- function( input, output, session) {
            VCFsummary <- reactive({ if (is.null(input$vcf_file$datapath)) return(NULL); summarizeVCF(input$vcf_file$datapath) } )
            
            output$IntermediateState= DT::renderDataTable({
                inFile <- VCFsummary()
                if (is.null(inFile)) return()
                data = read.table(inFile, head=T, sep="\t", stringsAsFactors=F)
                data 
            })

            output$Plots1 <- renderPlot({
                    
                inFile <- VCFsummary()
                if (is.null(inFile)) return() 
                Draw(inFile)
            })
            
}

shinyApp(ui = UI, server = SERVER)